<?php

namespace Stellae\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAsn_Line ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAsn_Line
 * @subpackage Arrays
 */
class ArrayOfAsn_Line extends AbstractStructArrayBase
{
    /**
     * The Asn_Line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\StructType\Asn_Line[]
     */
    public $Asn_Line;
    /**
     * Constructor method for ArrayOfAsn_Line
     * @uses ArrayOfAsn_Line::setAsn_Line()
     * @param \Stellae\StructType\Asn_Line[] $asn_Line
     */
    public function __construct(array $asn_Line = array())
    {
        $this
            ->setAsn_Line($asn_Line);
    }
    /**
     * Get Asn_Line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\StructType\Asn_Line[]|null
     */
    public function getAsn_Line()
    {
        return isset($this->Asn_Line) ? $this->Asn_Line : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAsn_Line method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAsn_Line method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAsn_LineForArrayConstraintsFromSetAsn_Line(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAsn_LineAsn_LineItem) {
            // validation for constraint: itemType
            if (!$arrayOfAsn_LineAsn_LineItem instanceof \Stellae\StructType\Asn_Line) {
                $invalidValues[] = is_object($arrayOfAsn_LineAsn_LineItem) ? get_class($arrayOfAsn_LineAsn_LineItem) : sprintf('%s(%s)', gettype($arrayOfAsn_LineAsn_LineItem), var_export($arrayOfAsn_LineAsn_LineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Asn_Line property can only contain items of type \Stellae\StructType\Asn_Line, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Asn_Line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Asn_Line[] $asn_Line
     * @return \Stellae\ArrayType\ArrayOfAsn_Line
     */
    public function setAsn_Line(array $asn_Line = array())
    {
        // validation for constraint: array
        if ('' !== ($asn_LineArrayErrorMessage = self::validateAsn_LineForArrayConstraintsFromSetAsn_Line($asn_Line))) {
            throw new \InvalidArgumentException($asn_LineArrayErrorMessage, __LINE__);
        }
        if (is_null($asn_Line) || (is_array($asn_Line) && empty($asn_Line))) {
            unset($this->Asn_Line);
        } else {
            $this->Asn_Line = $asn_Line;
        }
        return $this;
    }
    /**
     * Add item to Asn_Line value
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Asn_Line $item
     * @return \Stellae\ArrayType\ArrayOfAsn_Line
     */
    public function addToAsn_Line(\Stellae\StructType\Asn_Line $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Stellae\StructType\Asn_Line) {
            throw new \InvalidArgumentException(sprintf('The Asn_Line property can only contain items of type \Stellae\StructType\Asn_Line, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Asn_Line[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Stellae\StructType\Asn_Line|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Stellae\StructType\Asn_Line|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Stellae\StructType\Asn_Line|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Stellae\StructType\Asn_Line|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Stellae\StructType\Asn_Line|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Asn_Line
     */
    public function getAttributeName()
    {
        return 'Asn_Line';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\ArrayType\ArrayOfAsn_Line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
