<?php

namespace Stellae\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLine_list_row ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLine_list_row
 * @subpackage Arrays
 */
class ArrayOfLine_list_row extends AbstractStructArrayBase
{
    /**
     * The Line_list_row
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\StructType\Line_list_row[]
     */
    public $Line_list_row;
    /**
     * Constructor method for ArrayOfLine_list_row
     * @uses ArrayOfLine_list_row::setLine_list_row()
     * @param \Stellae\StructType\Line_list_row[] $line_list_row
     */
    public function __construct(array $line_list_row = array())
    {
        $this
            ->setLine_list_row($line_list_row);
    }
    /**
     * Get Line_list_row value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\StructType\Line_list_row[]|null
     */
    public function getLine_list_row()
    {
        return isset($this->Line_list_row) ? $this->Line_list_row : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLine_list_row method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLine_list_row method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLine_list_rowForArrayConstraintsFromSetLine_list_row(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLine_list_rowLine_list_rowItem) {
            // validation for constraint: itemType
            if (!$arrayOfLine_list_rowLine_list_rowItem instanceof \Stellae\StructType\Line_list_row) {
                $invalidValues[] = is_object($arrayOfLine_list_rowLine_list_rowItem) ? get_class($arrayOfLine_list_rowLine_list_rowItem) : sprintf('%s(%s)', gettype($arrayOfLine_list_rowLine_list_rowItem), var_export($arrayOfLine_list_rowLine_list_rowItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Line_list_row property can only contain items of type \Stellae\StructType\Line_list_row, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Line_list_row value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Line_list_row[] $line_list_row
     * @return \Stellae\ArrayType\ArrayOfLine_list_row
     */
    public function setLine_list_row(array $line_list_row = array())
    {
        // validation for constraint: array
        if ('' !== ($line_list_rowArrayErrorMessage = self::validateLine_list_rowForArrayConstraintsFromSetLine_list_row($line_list_row))) {
            throw new \InvalidArgumentException($line_list_rowArrayErrorMessage, __LINE__);
        }
        if (is_null($line_list_row) || (is_array($line_list_row) && empty($line_list_row))) {
            unset($this->Line_list_row);
        } else {
            $this->Line_list_row = $line_list_row;
        }
        return $this;
    }
    /**
     * Add item to Line_list_row value
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Line_list_row $item
     * @return \Stellae\ArrayType\ArrayOfLine_list_row
     */
    public function addToLine_list_row(\Stellae\StructType\Line_list_row $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Stellae\StructType\Line_list_row) {
            throw new \InvalidArgumentException(sprintf('The Line_list_row property can only contain items of type \Stellae\StructType\Line_list_row, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Line_list_row[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Stellae\StructType\Line_list_row|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Stellae\StructType\Line_list_row|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Stellae\StructType\Line_list_row|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Stellae\StructType\Line_list_row|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Stellae\StructType\Line_list_row|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Line_list_row
     */
    public function getAttributeName()
    {
        return 'Line_list_row';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\ArrayType\ArrayOfLine_list_row
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
