<?php

namespace Stellae\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrder_Detail_New ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrder_Detail_New
 * @subpackage Arrays
 */
class ArrayOfOrder_Detail_New extends AbstractStructArrayBase
{
    /**
     * The Order_Detail_New
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\StructType\Order_Detail_New[]
     */
    public $Order_Detail_New;
    /**
     * Constructor method for ArrayOfOrder_Detail_New
     * @uses ArrayOfOrder_Detail_New::setOrder_Detail_New()
     * @param \Stellae\StructType\Order_Detail_New[] $order_Detail_New
     */
    public function __construct(array $order_Detail_New = array())
    {
        $this
            ->setOrder_Detail_New($order_Detail_New);
    }
    /**
     * Get Order_Detail_New value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\StructType\Order_Detail_New[]|null
     */
    public function getOrder_Detail_New()
    {
        return isset($this->Order_Detail_New) ? $this->Order_Detail_New : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrder_Detail_New method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrder_Detail_New method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrder_Detail_NewForArrayConstraintsFromSetOrder_Detail_New(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrder_Detail_NewOrder_Detail_NewItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrder_Detail_NewOrder_Detail_NewItem instanceof \Stellae\StructType\Order_Detail_New) {
                $invalidValues[] = is_object($arrayOfOrder_Detail_NewOrder_Detail_NewItem) ? get_class($arrayOfOrder_Detail_NewOrder_Detail_NewItem) : sprintf('%s(%s)', gettype($arrayOfOrder_Detail_NewOrder_Detail_NewItem), var_export($arrayOfOrder_Detail_NewOrder_Detail_NewItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Order_Detail_New property can only contain items of type \Stellae\StructType\Order_Detail_New, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Order_Detail_New value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Order_Detail_New[] $order_Detail_New
     * @return \Stellae\ArrayType\ArrayOfOrder_Detail_New
     */
    public function setOrder_Detail_New(array $order_Detail_New = array())
    {
        // validation for constraint: array
        if ('' !== ($order_Detail_NewArrayErrorMessage = self::validateOrder_Detail_NewForArrayConstraintsFromSetOrder_Detail_New($order_Detail_New))) {
            throw new \InvalidArgumentException($order_Detail_NewArrayErrorMessage, __LINE__);
        }
        if (is_null($order_Detail_New) || (is_array($order_Detail_New) && empty($order_Detail_New))) {
            unset($this->Order_Detail_New);
        } else {
            $this->Order_Detail_New = $order_Detail_New;
        }
        return $this;
    }
    /**
     * Add item to Order_Detail_New value
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Order_Detail_New $item
     * @return \Stellae\ArrayType\ArrayOfOrder_Detail_New
     */
    public function addToOrder_Detail_New(\Stellae\StructType\Order_Detail_New $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Stellae\StructType\Order_Detail_New) {
            throw new \InvalidArgumentException(sprintf('The Order_Detail_New property can only contain items of type \Stellae\StructType\Order_Detail_New, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Order_Detail_New[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Stellae\StructType\Order_Detail_New|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Stellae\StructType\Order_Detail_New|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Stellae\StructType\Order_Detail_New|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Stellae\StructType\Order_Detail_New|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Stellae\StructType\Order_Detail_New|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Order_Detail_New
     */
    public function getAttributeName()
    {
        return 'Order_Detail_New';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\ArrayType\ArrayOfOrder_Detail_New
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
