<?php

namespace Stellae\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOforder_status_line ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOforder_status_line
 * @subpackage Arrays
 */
class ArrayOforder_status_line extends AbstractStructArrayBase
{
    /**
     * The order_status_line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\StructType\Order_status_line[]
     */
    public $order_status_line;
    /**
     * Constructor method for ArrayOforder_status_line
     * @uses ArrayOforder_status_line::setOrder_status_line()
     * @param \Stellae\StructType\Order_status_line[] $order_status_line
     */
    public function __construct(array $order_status_line = array())
    {
        $this
            ->setOrder_status_line($order_status_line);
    }
    /**
     * Get order_status_line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\StructType\Order_status_line[]|null
     */
    public function getOrder_status_line()
    {
        return isset($this->order_status_line) ? $this->order_status_line : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrder_status_line method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrder_status_line method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrder_status_lineForArrayConstraintsFromSetOrder_status_line(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOforder_status_lineOrder_status_lineItem) {
            // validation for constraint: itemType
            if (!$arrayOforder_status_lineOrder_status_lineItem instanceof \Stellae\StructType\Order_status_line) {
                $invalidValues[] = is_object($arrayOforder_status_lineOrder_status_lineItem) ? get_class($arrayOforder_status_lineOrder_status_lineItem) : sprintf('%s(%s)', gettype($arrayOforder_status_lineOrder_status_lineItem), var_export($arrayOforder_status_lineOrder_status_lineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The order_status_line property can only contain items of type \Stellae\StructType\Order_status_line, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set order_status_line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Order_status_line[] $order_status_line
     * @return \Stellae\ArrayType\ArrayOforder_status_line
     */
    public function setOrder_status_line(array $order_status_line = array())
    {
        // validation for constraint: array
        if ('' !== ($order_status_lineArrayErrorMessage = self::validateOrder_status_lineForArrayConstraintsFromSetOrder_status_line($order_status_line))) {
            throw new \InvalidArgumentException($order_status_lineArrayErrorMessage, __LINE__);
        }
        if (is_null($order_status_line) || (is_array($order_status_line) && empty($order_status_line))) {
            unset($this->order_status_line);
        } else {
            $this->order_status_line = $order_status_line;
        }
        return $this;
    }
    /**
     * Add item to order_status_line value
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Order_status_line $item
     * @return \Stellae\ArrayType\ArrayOforder_status_line
     */
    public function addToOrder_status_line(\Stellae\StructType\Order_status_line $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Stellae\StructType\Order_status_line) {
            throw new \InvalidArgumentException(sprintf('The order_status_line property can only contain items of type \Stellae\StructType\Order_status_line, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->order_status_line[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Stellae\StructType\Order_status_line|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Stellae\StructType\Order_status_line|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Stellae\StructType\Order_status_line|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Stellae\StructType\Order_status_line|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Stellae\StructType\Order_status_line|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string order_status_line
     */
    public function getAttributeName()
    {
        return 'order_status_line';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\ArrayType\ArrayOforder_status_line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
