<?php

namespace Stellae\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOforder_status_request ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOforder_status_request
 * @subpackage Arrays
 */
class ArrayOforder_status_request extends AbstractStructArrayBase
{
    /**
     * The order_status_request
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\StructType\Order_status_request[]
     */
    public $order_status_request;
    /**
     * Constructor method for ArrayOforder_status_request
     * @uses ArrayOforder_status_request::setOrder_status_request()
     * @param \Stellae\StructType\Order_status_request[] $order_status_request
     */
    public function __construct(array $order_status_request = array())
    {
        $this
            ->setOrder_status_request($order_status_request);
    }
    /**
     * Get order_status_request value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\StructType\Order_status_request[]|null
     */
    public function getOrder_status_request()
    {
        return isset($this->order_status_request) ? $this->order_status_request : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrder_status_request method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrder_status_request method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrder_status_requestForArrayConstraintsFromSetOrder_status_request(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOforder_status_requestOrder_status_requestItem) {
            // validation for constraint: itemType
            if (!$arrayOforder_status_requestOrder_status_requestItem instanceof \Stellae\StructType\Order_status_request) {
                $invalidValues[] = is_object($arrayOforder_status_requestOrder_status_requestItem) ? get_class($arrayOforder_status_requestOrder_status_requestItem) : sprintf('%s(%s)', gettype($arrayOforder_status_requestOrder_status_requestItem), var_export($arrayOforder_status_requestOrder_status_requestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The order_status_request property can only contain items of type \Stellae\StructType\Order_status_request, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set order_status_request value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Order_status_request[] $order_status_request
     * @return \Stellae\ArrayType\ArrayOforder_status_request
     */
    public function setOrder_status_request(array $order_status_request = array())
    {
        // validation for constraint: array
        if ('' !== ($order_status_requestArrayErrorMessage = self::validateOrder_status_requestForArrayConstraintsFromSetOrder_status_request($order_status_request))) {
            throw new \InvalidArgumentException($order_status_requestArrayErrorMessage, __LINE__);
        }
        if (is_null($order_status_request) || (is_array($order_status_request) && empty($order_status_request))) {
            unset($this->order_status_request);
        } else {
            $this->order_status_request = $order_status_request;
        }
        return $this;
    }
    /**
     * Add item to order_status_request value
     * @throws \InvalidArgumentException
     * @param \Stellae\StructType\Order_status_request $item
     * @return \Stellae\ArrayType\ArrayOforder_status_request
     */
    public function addToOrder_status_request(\Stellae\StructType\Order_status_request $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Stellae\StructType\Order_status_request) {
            throw new \InvalidArgumentException(sprintf('The order_status_request property can only contain items of type \Stellae\StructType\Order_status_request, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->order_status_request[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Stellae\StructType\Order_status_request|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Stellae\StructType\Order_status_request|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Stellae\StructType\Order_status_request|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Stellae\StructType\Order_status_request|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Stellae\StructType\Order_status_request|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string order_status_request
     */
    public function getAttributeName()
    {
        return 'order_status_request';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\ArrayType\ArrayOforder_status_request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
