<?php

namespace Stellae;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfstring' => '\\Stellae\\ArrayType\\ArrayOfstring',
            'UserName' => '\\Stellae\\StructType\\UserName',
            'ArrayOfUPC_Inventory_Request' => '\\Stellae\\ArrayType\\ArrayOfUPC_Inventory_Request',
            'UPC_Inventory_Request' => '\\Stellae\\StructType\\UPC_Inventory_Request',
            'RequestResponse' => '\\Stellae\\StructType\\RequestResponse',
            'ArrayOfUPC_Inventory_Response' => '\\Stellae\\ArrayType\\ArrayOfUPC_Inventory_Response',
            'UPC_Inventory_Response' => '\\Stellae\\StructType\\UPC_Inventory_Response',
            'Order_Header_New' => '\\Stellae\\StructType\\Order_Header_New',
            'ArrayOfOrder_Detail_New' => '\\Stellae\\ArrayType\\ArrayOfOrder_Detail_New',
            'Order_Detail_New' => '\\Stellae\\StructType\\Order_Detail_New',
            'NewOrderRequestResponse' => '\\Stellae\\StructType\\NewOrderRequestResponse',
            'Shipment_Request' => '\\Stellae\\StructType\\Shipment_Request',
            'NewShipmentRequestResponse' => '\\Stellae\\StructType\\NewShipmentRequestResponse',
            'ArrayOfshipment_status' => '\\Stellae\\ArrayType\\ArrayOfshipment_status',
            'shipment_status' => '\\Stellae\\StructType\\Shipment_status',
            'ArrayOfshipment_cartons' => '\\Stellae\\ArrayType\\ArrayOfshipment_cartons',
            'shipment_cartons' => '\\Stellae\\StructType\\Shipment_cartons',
            'Catalog_items_request' => '\\Stellae\\StructType\\Catalog_items_request',
            'Catalog_items_response' => '\\Stellae\\StructType\\Catalog_items_response',
            'ArrayOfcatalog_item' => '\\Stellae\\ArrayType\\ArrayOfcatalog_item',
            'catalog_item' => '\\Stellae\\StructType\\Catalog_item',
            'ArrayOfLine_list_row' => '\\Stellae\\ArrayType\\ArrayOfLine_list_row',
            'Line_list_row' => '\\Stellae\\StructType\\Line_list_row',
            'purchase_Order_Header_New' => '\\Stellae\\StructType\\Purchase_Order_Header_New',
            'purchase_Order_receipt_request' => '\\Stellae\\StructType\\Purchase_Order_receipt_request',
            'Purchase_Order_Receipt_Response' => '\\Stellae\\StructType\\Purchase_Order_Receipt_Response',
            'ArrayOfPurchase_Order_Receipt_Item' => '\\Stellae\\ArrayType\\ArrayOfPurchase_Order_Receipt_Item',
            'Purchase_Order_Receipt_Item' => '\\Stellae\\StructType\\Purchase_Order_Receipt_Item',
            'Asn_Header_New' => '\\Stellae\\StructType\\Asn_Header_New',
            'ArrayOfAsn_Line' => '\\Stellae\\ArrayType\\ArrayOfAsn_Line',
            'Asn_Line' => '\\Stellae\\StructType\\Asn_Line',
            'New_Delivery_Ticket' => '\\Stellae\\StructType\\New_Delivery_Ticket',
            'ArrayOforder_status_request' => '\\Stellae\\ArrayType\\ArrayOforder_status_request',
            'order_status_request' => '\\Stellae\\StructType\\Order_status_request',
            'order_status_reply' => '\\Stellae\\StructType\\Order_status_reply',
            'ArrayOforder_status_order' => '\\Stellae\\ArrayType\\ArrayOforder_status_order',
            'order_status_order' => '\\Stellae\\StructType\\Order_status_order',
            'ArrayOforder_status_line' => '\\Stellae\\ArrayType\\ArrayOforder_status_line',
            'order_status_line' => '\\Stellae\\StructType\\Order_status_line',
            'Invoice_information' => '\\Stellae\\StructType\\Invoice_information',
            'ArrayOfinvoice_line' => '\\Stellae\\ArrayType\\ArrayOfinvoice_line',
            'invoice_line' => '\\Stellae\\StructType\\Invoice_line',
            'get_inventory_on_hand' => '\\Stellae\\StructType\\Get_inventory_on_hand',
            'get_inventory_on_handResponse' => '\\Stellae\\StructType\\Get_inventory_on_handResponse',
            'new_order_entry' => '\\Stellae\\StructType\\New_order_entry',
            'new_order_entryResponse' => '\\Stellae\\StructType\\New_order_entryResponse',
            'get_shipment_information' => '\\Stellae\\StructType\\Get_shipment_information',
            'get_shipment_informationResponse' => '\\Stellae\\StructType\\Get_shipment_informationResponse',
            'get_catalog_information' => '\\Stellae\\StructType\\Get_catalog_information',
            'get_catalog_informationResponse' => '\\Stellae\\StructType\\Get_catalog_informationResponse',
            'import_line_list' => '\\Stellae\\StructType\\Import_line_list',
            'import_line_listResponse' => '\\Stellae\\StructType\\Import_line_listResponse',
            'new_purchase_order_entry' => '\\Stellae\\StructType\\New_purchase_order_entry',
            'new_purchase_order_entryResponse' => '\\Stellae\\StructType\\New_purchase_order_entryResponse',
            'get_purchase_order_receipt' => '\\Stellae\\StructType\\Get_purchase_order_receipt',
            'get_purchase_order_receiptResponse' => '\\Stellae\\StructType\\Get_purchase_order_receiptResponse',
            'new_asn_entry' => '\\Stellae\\StructType\\New_asn_entry',
            'new_asn_entryResponse' => '\\Stellae\\StructType\\New_asn_entryResponse',
            'new_delivery_ticket' => '\\Stellae\\StructType\\New_delivery_ticket_1',
            'new_delivery_ticketResponse' => '\\Stellae\\StructType\\New_delivery_ticketResponse',
            'order_status' => '\\Stellae\\StructType\\Order_status',
            'order_statusResponse' => '\\Stellae\\StructType\\Order_statusResponse',
            'import_invoice' => '\\Stellae\\StructType\\Import_invoice',
            'import_invoiceResponse' => '\\Stellae\\StructType\\Import_invoiceResponse',
        );
    }
}
