<?php

namespace Stellae\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Getcataloginformation ServiceType
 * @subpackage Services
 */
class Getcataloginformation extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named get_catalog_information
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Stellae\StructType\Get_catalog_information $parameters
     * @return \Stellae\StructType\Get_catalog_informationResponse|bool
     */
    public function get_catalog_information(\Stellae\StructType\Get_catalog_information $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->get_catalog_information($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \Stellae\StructType\Get_catalog_informationResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
