<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Catalog_items_response StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Catalog_items_response
 * @subpackage Structs
 */
class Catalog_items_response extends AbstractStructBase
{
    /**
     * The catalog_items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\ArrayType\ArrayOfcatalog_item
     */
    public $catalog_items;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $status;
    /**
     * Constructor method for Catalog_items_response
     * @uses Catalog_items_response::setCatalog_items()
     * @uses Catalog_items_response::setStatus()
     * @param \Stellae\ArrayType\ArrayOfcatalog_item $catalog_items
     * @param string $status
     */
    public function __construct(\Stellae\ArrayType\ArrayOfcatalog_item $catalog_items = null, $status = null)
    {
        $this
            ->setCatalog_items($catalog_items)
            ->setStatus($status);
    }
    /**
     * Get catalog_items value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\ArrayType\ArrayOfcatalog_item|null
     */
    public function getCatalog_items()
    {
        return isset($this->catalog_items) ? $this->catalog_items : null;
    }
    /**
     * Set catalog_items value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\ArrayType\ArrayOfcatalog_item $catalog_items
     * @return \Stellae\StructType\Catalog_items_response
     */
    public function setCatalog_items(\Stellae\ArrayType\ArrayOfcatalog_item $catalog_items = null)
    {
        if (is_null($catalog_items) || (is_array($catalog_items) && empty($catalog_items))) {
            unset($this->catalog_items);
        } else {
            $this->catalog_items = $catalog_items;
        }
        return $this;
    }
    /**
     * Get status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatus()
    {
        return isset($this->status) ? $this->status : null;
    }
    /**
     * Set status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $status
     * @return \Stellae\StructType\Catalog_items_response
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->status);
        } else {
            $this->status = $status;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Catalog_items_response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
