<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for get_inventory_on_hand StructType
 * @subpackage Structs
 */
class Get_inventory_on_hand extends AbstractStructBase
{
    /**
     * The user
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\StructType\UserName
     */
    public $user;
    /**
     * The upcs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\ArrayType\ArrayOfUPC_Inventory_Request
     */
    public $upcs;
    /**
     * Constructor method for get_inventory_on_hand
     * @uses Get_inventory_on_hand::setUser()
     * @uses Get_inventory_on_hand::setUpcs()
     * @param \Stellae\StructType\UserName $user
     * @param \Stellae\ArrayType\ArrayOfUPC_Inventory_Request $upcs
     */
    public function __construct(\Stellae\StructType\UserName $user = null, \Stellae\ArrayType\ArrayOfUPC_Inventory_Request $upcs = null)
    {
        $this
            ->setUser($user)
            ->setUpcs($upcs);
    }
    /**
     * Get user value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\StructType\UserName|null
     */
    public function getUser()
    {
        return isset($this->user) ? $this->user : null;
    }
    /**
     * Set user value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\StructType\UserName $user
     * @return \Stellae\StructType\Get_inventory_on_hand
     */
    public function setUser(\Stellae\StructType\UserName $user = null)
    {
        if (is_null($user) || (is_array($user) && empty($user))) {
            unset($this->user);
        } else {
            $this->user = $user;
        }
        return $this;
    }
    /**
     * Get upcs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\ArrayType\ArrayOfUPC_Inventory_Request|null
     */
    public function getUpcs()
    {
        return isset($this->upcs) ? $this->upcs : null;
    }
    /**
     * Set upcs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\ArrayType\ArrayOfUPC_Inventory_Request $upcs
     * @return \Stellae\StructType\Get_inventory_on_hand
     */
    public function setUpcs(\Stellae\ArrayType\ArrayOfUPC_Inventory_Request $upcs = null)
    {
        if (is_null($upcs) || (is_array($upcs) && empty($upcs))) {
            unset($this->upcs);
        } else {
            $this->upcs = $upcs;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Get_inventory_on_hand
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
