<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for invoice_line StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:invoice_line
 * @subpackage Structs
 */
class Invoice_line extends AbstractStructBase
{
    /**
     * The Bundle_Id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Bundle_Id;
    /**
     * The Delivery_Id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Delivery_Id;
    /**
     * The PRICE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $PRICE;
    /**
     * The QUANTITY
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $QUANTITY;
    /**
     * The SKU
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SKU;
    /**
     * Constructor method for invoice_line
     * @uses Invoice_line::setBundle_Id()
     * @uses Invoice_line::setDelivery_Id()
     * @uses Invoice_line::setPRICE()
     * @uses Invoice_line::setQUANTITY()
     * @uses Invoice_line::setSKU()
     * @param string $bundle_Id
     * @param string $delivery_Id
     * @param float $pRICE
     * @param float $qUANTITY
     * @param string $sKU
     */
    public function __construct($bundle_Id = null, $delivery_Id = null, $pRICE = null, $qUANTITY = null, $sKU = null)
    {
        $this
            ->setBundle_Id($bundle_Id)
            ->setDelivery_Id($delivery_Id)
            ->setPRICE($pRICE)
            ->setQUANTITY($qUANTITY)
            ->setSKU($sKU);
    }
    /**
     * Get Bundle_Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBundle_Id()
    {
        return isset($this->Bundle_Id) ? $this->Bundle_Id : null;
    }
    /**
     * Set Bundle_Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bundle_Id
     * @return \Stellae\StructType\Invoice_line
     */
    public function setBundle_Id($bundle_Id = null)
    {
        // validation for constraint: string
        if (!is_null($bundle_Id) && !is_string($bundle_Id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bundle_Id, true), gettype($bundle_Id)), __LINE__);
        }
        if (is_null($bundle_Id) || (is_array($bundle_Id) && empty($bundle_Id))) {
            unset($this->Bundle_Id);
        } else {
            $this->Bundle_Id = $bundle_Id;
        }
        return $this;
    }
    /**
     * Get Delivery_Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDelivery_Id()
    {
        return isset($this->Delivery_Id) ? $this->Delivery_Id : null;
    }
    /**
     * Set Delivery_Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $delivery_Id
     * @return \Stellae\StructType\Invoice_line
     */
    public function setDelivery_Id($delivery_Id = null)
    {
        // validation for constraint: string
        if (!is_null($delivery_Id) && !is_string($delivery_Id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($delivery_Id, true), gettype($delivery_Id)), __LINE__);
        }
        if (is_null($delivery_Id) || (is_array($delivery_Id) && empty($delivery_Id))) {
            unset($this->Delivery_Id);
        } else {
            $this->Delivery_Id = $delivery_Id;
        }
        return $this;
    }
    /**
     * Get PRICE value
     * @return float|null
     */
    public function getPRICE()
    {
        return $this->PRICE;
    }
    /**
     * Set PRICE value
     * @param float $pRICE
     * @return \Stellae\StructType\Invoice_line
     */
    public function setPRICE($pRICE = null)
    {
        // validation for constraint: float
        if (!is_null($pRICE) && !(is_float($pRICE) || is_numeric($pRICE))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pRICE, true), gettype($pRICE)), __LINE__);
        }
        $this->PRICE = $pRICE;
        return $this;
    }
    /**
     * Get QUANTITY value
     * @return float|null
     */
    public function getQUANTITY()
    {
        return $this->QUANTITY;
    }
    /**
     * Set QUANTITY value
     * @param float $qUANTITY
     * @return \Stellae\StructType\Invoice_line
     */
    public function setQUANTITY($qUANTITY = null)
    {
        // validation for constraint: float
        if (!is_null($qUANTITY) && !(is_float($qUANTITY) || is_numeric($qUANTITY))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($qUANTITY, true), gettype($qUANTITY)), __LINE__);
        }
        $this->QUANTITY = $qUANTITY;
        return $this;
    }
    /**
     * Get SKU value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSKU()
    {
        return isset($this->SKU) ? $this->SKU : null;
    }
    /**
     * Set SKU value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sKU
     * @return \Stellae\StructType\Invoice_line
     */
    public function setSKU($sKU = null)
    {
        // validation for constraint: string
        if (!is_null($sKU) && !is_string($sKU)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sKU, true), gettype($sKU)), __LINE__);
        }
        if (is_null($sKU) || (is_array($sKU) && empty($sKU))) {
            unset($this->SKU);
        } else {
            $this->SKU = $sKU;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Invoice_line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
