<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for order_status StructType
 * @subpackage Structs
 */
class Order_status extends AbstractStructBase
{
    /**
     * The user
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\StructType\UserName
     */
    public $user;
    /**
     * The order_request_rows
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\ArrayType\ArrayOforder_status_request
     */
    public $order_request_rows;
    /**
     * Constructor method for order_status
     * @uses Order_status::setUser()
     * @uses Order_status::setOrder_request_rows()
     * @param \Stellae\StructType\UserName $user
     * @param \Stellae\ArrayType\ArrayOforder_status_request $order_request_rows
     */
    public function __construct(\Stellae\StructType\UserName $user = null, \Stellae\ArrayType\ArrayOforder_status_request $order_request_rows = null)
    {
        $this
            ->setUser($user)
            ->setOrder_request_rows($order_request_rows);
    }
    /**
     * Get user value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\StructType\UserName|null
     */
    public function getUser()
    {
        return isset($this->user) ? $this->user : null;
    }
    /**
     * Set user value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\StructType\UserName $user
     * @return \Stellae\StructType\Order_status
     */
    public function setUser(\Stellae\StructType\UserName $user = null)
    {
        if (is_null($user) || (is_array($user) && empty($user))) {
            unset($this->user);
        } else {
            $this->user = $user;
        }
        return $this;
    }
    /**
     * Get order_request_rows value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\ArrayType\ArrayOforder_status_request|null
     */
    public function getOrder_request_rows()
    {
        return isset($this->order_request_rows) ? $this->order_request_rows : null;
    }
    /**
     * Set order_request_rows value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\ArrayType\ArrayOforder_status_request $order_request_rows
     * @return \Stellae\StructType\Order_status
     */
    public function setOrder_request_rows(\Stellae\ArrayType\ArrayOforder_status_request $order_request_rows = null)
    {
        if (is_null($order_request_rows) || (is_array($order_request_rows) && empty($order_request_rows))) {
            unset($this->order_request_rows);
        } else {
            $this->order_request_rows = $order_request_rows;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Order_status
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
