<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for order_status_order StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:order_status_order
 * @subpackage Structs
 */
class Order_status_order extends AbstractStructBase
{
    /**
     * The designer_order
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $designer_order;
    /**
     * The order_status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $order_status;
    /**
     * The order_status_lines
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\ArrayType\ArrayOforder_status_line
     */
    public $order_status_lines;
    /**
     * The other_reference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $other_reference;
    /**
     * The stellae_order
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $stellae_order;
    /**
     * Constructor method for order_status_order
     * @uses Order_status_order::setDesigner_order()
     * @uses Order_status_order::setOrder_status()
     * @uses Order_status_order::setOrder_status_lines()
     * @uses Order_status_order::setOther_reference()
     * @uses Order_status_order::setStellae_order()
     * @param string $designer_order
     * @param string $order_status
     * @param \Stellae\ArrayType\ArrayOforder_status_line $order_status_lines
     * @param string $other_reference
     * @param float $stellae_order
     */
    public function __construct($designer_order = null, $order_status = null, \Stellae\ArrayType\ArrayOforder_status_line $order_status_lines = null, $other_reference = null, $stellae_order = null)
    {
        $this
            ->setDesigner_order($designer_order)
            ->setOrder_status($order_status)
            ->setOrder_status_lines($order_status_lines)
            ->setOther_reference($other_reference)
            ->setStellae_order($stellae_order);
    }
    /**
     * Get designer_order value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDesigner_order()
    {
        return isset($this->designer_order) ? $this->designer_order : null;
    }
    /**
     * Set designer_order value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $designer_order
     * @return \Stellae\StructType\Order_status_order
     */
    public function setDesigner_order($designer_order = null)
    {
        // validation for constraint: string
        if (!is_null($designer_order) && !is_string($designer_order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($designer_order, true), gettype($designer_order)), __LINE__);
        }
        if (is_null($designer_order) || (is_array($designer_order) && empty($designer_order))) {
            unset($this->designer_order);
        } else {
            $this->designer_order = $designer_order;
        }
        return $this;
    }
    /**
     * Get order_status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrder_status()
    {
        return isset($this->order_status) ? $this->order_status : null;
    }
    /**
     * Set order_status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $order_status
     * @return \Stellae\StructType\Order_status_order
     */
    public function setOrder_status($order_status = null)
    {
        // validation for constraint: string
        if (!is_null($order_status) && !is_string($order_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($order_status, true), gettype($order_status)), __LINE__);
        }
        if (is_null($order_status) || (is_array($order_status) && empty($order_status))) {
            unset($this->order_status);
        } else {
            $this->order_status = $order_status;
        }
        return $this;
    }
    /**
     * Get order_status_lines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\ArrayType\ArrayOforder_status_line|null
     */
    public function getOrder_status_lines()
    {
        return isset($this->order_status_lines) ? $this->order_status_lines : null;
    }
    /**
     * Set order_status_lines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\ArrayType\ArrayOforder_status_line $order_status_lines
     * @return \Stellae\StructType\Order_status_order
     */
    public function setOrder_status_lines(\Stellae\ArrayType\ArrayOforder_status_line $order_status_lines = null)
    {
        if (is_null($order_status_lines) || (is_array($order_status_lines) && empty($order_status_lines))) {
            unset($this->order_status_lines);
        } else {
            $this->order_status_lines = $order_status_lines;
        }
        return $this;
    }
    /**
     * Get other_reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOther_reference()
    {
        return isset($this->other_reference) ? $this->other_reference : null;
    }
    /**
     * Set other_reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $other_reference
     * @return \Stellae\StructType\Order_status_order
     */
    public function setOther_reference($other_reference = null)
    {
        // validation for constraint: string
        if (!is_null($other_reference) && !is_string($other_reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($other_reference, true), gettype($other_reference)), __LINE__);
        }
        if (is_null($other_reference) || (is_array($other_reference) && empty($other_reference))) {
            unset($this->other_reference);
        } else {
            $this->other_reference = $other_reference;
        }
        return $this;
    }
    /**
     * Get stellae_order value
     * @return float|null
     */
    public function getStellae_order()
    {
        return $this->stellae_order;
    }
    /**
     * Set stellae_order value
     * @param float $stellae_order
     * @return \Stellae\StructType\Order_status_order
     */
    public function setStellae_order($stellae_order = null)
    {
        // validation for constraint: float
        if (!is_null($stellae_order) && !(is_float($stellae_order) || is_numeric($stellae_order))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($stellae_order, true), gettype($stellae_order)), __LINE__);
        }
        $this->stellae_order = $stellae_order;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Order_status_order
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
