<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for order_status_request StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:order_status_request
 * @subpackage Structs
 */
class Order_status_request extends AbstractStructBase
{
    /**
     * The designer_order
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $designer_order;
    /**
     * The entry_date_from
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $entry_date_from;
    /**
     * The entry_date_to
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $entry_date_to;
    /**
     * The order_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $order_type;
    /**
     * The other_reference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $other_reference;
    /**
     * The stellae_order
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $stellae_order;
    /**
     * Constructor method for order_status_request
     * @uses Order_status_request::setDesigner_order()
     * @uses Order_status_request::setEntry_date_from()
     * @uses Order_status_request::setEntry_date_to()
     * @uses Order_status_request::setOrder_type()
     * @uses Order_status_request::setOther_reference()
     * @uses Order_status_request::setStellae_order()
     * @param string $designer_order
     * @param string $entry_date_from
     * @param string $entry_date_to
     * @param string $order_type
     * @param string $other_reference
     * @param float $stellae_order
     */
    public function __construct($designer_order = null, $entry_date_from = null, $entry_date_to = null, $order_type = null, $other_reference = null, $stellae_order = null)
    {
        $this
            ->setDesigner_order($designer_order)
            ->setEntry_date_from($entry_date_from)
            ->setEntry_date_to($entry_date_to)
            ->setOrder_type($order_type)
            ->setOther_reference($other_reference)
            ->setStellae_order($stellae_order);
    }
    /**
     * Get designer_order value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDesigner_order()
    {
        return isset($this->designer_order) ? $this->designer_order : null;
    }
    /**
     * Set designer_order value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $designer_order
     * @return \Stellae\StructType\Order_status_request
     */
    public function setDesigner_order($designer_order = null)
    {
        // validation for constraint: string
        if (!is_null($designer_order) && !is_string($designer_order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($designer_order, true), gettype($designer_order)), __LINE__);
        }
        if (is_null($designer_order) || (is_array($designer_order) && empty($designer_order))) {
            unset($this->designer_order);
        } else {
            $this->designer_order = $designer_order;
        }
        return $this;
    }
    /**
     * Get entry_date_from value
     * @return string|null
     */
    public function getEntry_date_from()
    {
        return $this->entry_date_from;
    }
    /**
     * Set entry_date_from value
     * @param string $entry_date_from
     * @return \Stellae\StructType\Order_status_request
     */
    public function setEntry_date_from($entry_date_from = null)
    {
        // validation for constraint: string
        if (!is_null($entry_date_from) && !is_string($entry_date_from)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($entry_date_from, true), gettype($entry_date_from)), __LINE__);
        }
        $this->entry_date_from = $entry_date_from;
        return $this;
    }
    /**
     * Get entry_date_to value
     * @return string|null
     */
    public function getEntry_date_to()
    {
        return $this->entry_date_to;
    }
    /**
     * Set entry_date_to value
     * @param string $entry_date_to
     * @return \Stellae\StructType\Order_status_request
     */
    public function setEntry_date_to($entry_date_to = null)
    {
        // validation for constraint: string
        if (!is_null($entry_date_to) && !is_string($entry_date_to)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($entry_date_to, true), gettype($entry_date_to)), __LINE__);
        }
        $this->entry_date_to = $entry_date_to;
        return $this;
    }
    /**
     * Get order_type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrder_type()
    {
        return isset($this->order_type) ? $this->order_type : null;
    }
    /**
     * Set order_type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $order_type
     * @return \Stellae\StructType\Order_status_request
     */
    public function setOrder_type($order_type = null)
    {
        // validation for constraint: string
        if (!is_null($order_type) && !is_string($order_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($order_type, true), gettype($order_type)), __LINE__);
        }
        if (is_null($order_type) || (is_array($order_type) && empty($order_type))) {
            unset($this->order_type);
        } else {
            $this->order_type = $order_type;
        }
        return $this;
    }
    /**
     * Get other_reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOther_reference()
    {
        return isset($this->other_reference) ? $this->other_reference : null;
    }
    /**
     * Set other_reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $other_reference
     * @return \Stellae\StructType\Order_status_request
     */
    public function setOther_reference($other_reference = null)
    {
        // validation for constraint: string
        if (!is_null($other_reference) && !is_string($other_reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($other_reference, true), gettype($other_reference)), __LINE__);
        }
        if (is_null($other_reference) || (is_array($other_reference) && empty($other_reference))) {
            unset($this->other_reference);
        } else {
            $this->other_reference = $other_reference;
        }
        return $this;
    }
    /**
     * Get stellae_order value
     * @return float|null
     */
    public function getStellae_order()
    {
        return $this->stellae_order;
    }
    /**
     * Set stellae_order value
     * @param float $stellae_order
     * @return \Stellae\StructType\Order_status_request
     */
    public function setStellae_order($stellae_order = null)
    {
        // validation for constraint: float
        if (!is_null($stellae_order) && !(is_float($stellae_order) || is_numeric($stellae_order))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($stellae_order, true), gettype($stellae_order)), __LINE__);
        }
        $this->stellae_order = $stellae_order;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Order_status_request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
