<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for shipment_cartons StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:shipment_cartons
 * @subpackage Structs
 */
class Shipment_cartons extends AbstractStructBase
{
    /**
     * The CARRIER
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CARRIER;
    /**
     * The CTNWEIGHT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CTNWEIGHT;
    /**
     * The RETURN_TRACKING
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RETURN_TRACKING;
    /**
     * The SERVICE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SERVICE;
    /**
     * The TRACKING
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TRACKING;
    /**
     * The UCC128
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UCC128;
    /**
     * The carton_items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\ArrayType\ArrayOfOrder_Detail_New
     */
    public $carton_items;
    /**
     * Constructor method for shipment_cartons
     * @uses Shipment_cartons::setCARRIER()
     * @uses Shipment_cartons::setCTNWEIGHT()
     * @uses Shipment_cartons::setRETURN_TRACKING()
     * @uses Shipment_cartons::setSERVICE()
     * @uses Shipment_cartons::setTRACKING()
     * @uses Shipment_cartons::setUCC128()
     * @uses Shipment_cartons::setCarton_items()
     * @param string $cARRIER
     * @param string $cTNWEIGHT
     * @param string $rETURN_TRACKING
     * @param string $sERVICE
     * @param string $tRACKING
     * @param string $uCC128
     * @param \Stellae\ArrayType\ArrayOfOrder_Detail_New $carton_items
     */
    public function __construct($cARRIER = null, $cTNWEIGHT = null, $rETURN_TRACKING = null, $sERVICE = null, $tRACKING = null, $uCC128 = null, \Stellae\ArrayType\ArrayOfOrder_Detail_New $carton_items = null)
    {
        $this
            ->setCARRIER($cARRIER)
            ->setCTNWEIGHT($cTNWEIGHT)
            ->setRETURN_TRACKING($rETURN_TRACKING)
            ->setSERVICE($sERVICE)
            ->setTRACKING($tRACKING)
            ->setUCC128($uCC128)
            ->setCarton_items($carton_items);
    }
    /**
     * Get CARRIER value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCARRIER()
    {
        return isset($this->CARRIER) ? $this->CARRIER : null;
    }
    /**
     * Set CARRIER value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cARRIER
     * @return \Stellae\StructType\Shipment_cartons
     */
    public function setCARRIER($cARRIER = null)
    {
        // validation for constraint: string
        if (!is_null($cARRIER) && !is_string($cARRIER)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cARRIER, true), gettype($cARRIER)), __LINE__);
        }
        if (is_null($cARRIER) || (is_array($cARRIER) && empty($cARRIER))) {
            unset($this->CARRIER);
        } else {
            $this->CARRIER = $cARRIER;
        }
        return $this;
    }
    /**
     * Get CTNWEIGHT value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCTNWEIGHT()
    {
        return isset($this->CTNWEIGHT) ? $this->CTNWEIGHT : null;
    }
    /**
     * Set CTNWEIGHT value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cTNWEIGHT
     * @return \Stellae\StructType\Shipment_cartons
     */
    public function setCTNWEIGHT($cTNWEIGHT = null)
    {
        // validation for constraint: string
        if (!is_null($cTNWEIGHT) && !is_string($cTNWEIGHT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cTNWEIGHT, true), gettype($cTNWEIGHT)), __LINE__);
        }
        if (is_null($cTNWEIGHT) || (is_array($cTNWEIGHT) && empty($cTNWEIGHT))) {
            unset($this->CTNWEIGHT);
        } else {
            $this->CTNWEIGHT = $cTNWEIGHT;
        }
        return $this;
    }
    /**
     * Get RETURN_TRACKING value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRETURN_TRACKING()
    {
        return isset($this->RETURN_TRACKING) ? $this->RETURN_TRACKING : null;
    }
    /**
     * Set RETURN_TRACKING value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $rETURN_TRACKING
     * @return \Stellae\StructType\Shipment_cartons
     */
    public function setRETURN_TRACKING($rETURN_TRACKING = null)
    {
        // validation for constraint: string
        if (!is_null($rETURN_TRACKING) && !is_string($rETURN_TRACKING)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rETURN_TRACKING, true), gettype($rETURN_TRACKING)), __LINE__);
        }
        if (is_null($rETURN_TRACKING) || (is_array($rETURN_TRACKING) && empty($rETURN_TRACKING))) {
            unset($this->RETURN_TRACKING);
        } else {
            $this->RETURN_TRACKING = $rETURN_TRACKING;
        }
        return $this;
    }
    /**
     * Get SERVICE value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSERVICE()
    {
        return isset($this->SERVICE) ? $this->SERVICE : null;
    }
    /**
     * Set SERVICE value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sERVICE
     * @return \Stellae\StructType\Shipment_cartons
     */
    public function setSERVICE($sERVICE = null)
    {
        // validation for constraint: string
        if (!is_null($sERVICE) && !is_string($sERVICE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sERVICE, true), gettype($sERVICE)), __LINE__);
        }
        if (is_null($sERVICE) || (is_array($sERVICE) && empty($sERVICE))) {
            unset($this->SERVICE);
        } else {
            $this->SERVICE = $sERVICE;
        }
        return $this;
    }
    /**
     * Get TRACKING value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTRACKING()
    {
        return isset($this->TRACKING) ? $this->TRACKING : null;
    }
    /**
     * Set TRACKING value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tRACKING
     * @return \Stellae\StructType\Shipment_cartons
     */
    public function setTRACKING($tRACKING = null)
    {
        // validation for constraint: string
        if (!is_null($tRACKING) && !is_string($tRACKING)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tRACKING, true), gettype($tRACKING)), __LINE__);
        }
        if (is_null($tRACKING) || (is_array($tRACKING) && empty($tRACKING))) {
            unset($this->TRACKING);
        } else {
            $this->TRACKING = $tRACKING;
        }
        return $this;
    }
    /**
     * Get UCC128 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUCC128()
    {
        return isset($this->UCC128) ? $this->UCC128 : null;
    }
    /**
     * Set UCC128 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uCC128
     * @return \Stellae\StructType\Shipment_cartons
     */
    public function setUCC128($uCC128 = null)
    {
        // validation for constraint: string
        if (!is_null($uCC128) && !is_string($uCC128)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uCC128, true), gettype($uCC128)), __LINE__);
        }
        if (is_null($uCC128) || (is_array($uCC128) && empty($uCC128))) {
            unset($this->UCC128);
        } else {
            $this->UCC128 = $uCC128;
        }
        return $this;
    }
    /**
     * Get carton_items value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\ArrayType\ArrayOfOrder_Detail_New|null
     */
    public function getCarton_items()
    {
        return isset($this->carton_items) ? $this->carton_items : null;
    }
    /**
     * Set carton_items value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\ArrayType\ArrayOfOrder_Detail_New $carton_items
     * @return \Stellae\StructType\Shipment_cartons
     */
    public function setCarton_items(\Stellae\ArrayType\ArrayOfOrder_Detail_New $carton_items = null)
    {
        if (is_null($carton_items) || (is_array($carton_items) && empty($carton_items))) {
            unset($this->carton_items);
        } else {
            $this->carton_items = $carton_items;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Shipment_cartons
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
