<?php

namespace Stellae\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for shipment_status StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:shipment_status
 * @subpackage Structs
 */
class Shipment_status extends AbstractStructBase
{
    /**
     * The CUSTOMER_CODE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CUSTOMER_CODE;
    /**
     * The DELIVERY_DC_EDI
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DELIVERY_DC_EDI;
    /**
     * The DELIVERY_DOOR_EDI
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DELIVERY_DOOR_EDI;
    /**
     * The cartons
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Stellae\ArrayType\ArrayOfshipment_cartons
     */
    public $cartons;
    /**
     * The invoice_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $invoice_date;
    /**
     * The invoice_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $invoice_number;
    /**
     * The invoice_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $invoice_type;
    /**
     * The order_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $order_id;
    /**
     * Constructor method for shipment_status
     * @uses Shipment_status::setCUSTOMER_CODE()
     * @uses Shipment_status::setDELIVERY_DC_EDI()
     * @uses Shipment_status::setDELIVERY_DOOR_EDI()
     * @uses Shipment_status::setCartons()
     * @uses Shipment_status::setInvoice_date()
     * @uses Shipment_status::setInvoice_number()
     * @uses Shipment_status::setInvoice_type()
     * @uses Shipment_status::setOrder_id()
     * @param string $cUSTOMER_CODE
     * @param string $dELIVERY_DC_EDI
     * @param string $dELIVERY_DOOR_EDI
     * @param \Stellae\ArrayType\ArrayOfshipment_cartons $cartons
     * @param string $invoice_date
     * @param string $invoice_number
     * @param string $invoice_type
     * @param string $order_id
     */
    public function __construct($cUSTOMER_CODE = null, $dELIVERY_DC_EDI = null, $dELIVERY_DOOR_EDI = null, \Stellae\ArrayType\ArrayOfshipment_cartons $cartons = null, $invoice_date = null, $invoice_number = null, $invoice_type = null, $order_id = null)
    {
        $this
            ->setCUSTOMER_CODE($cUSTOMER_CODE)
            ->setDELIVERY_DC_EDI($dELIVERY_DC_EDI)
            ->setDELIVERY_DOOR_EDI($dELIVERY_DOOR_EDI)
            ->setCartons($cartons)
            ->setInvoice_date($invoice_date)
            ->setInvoice_number($invoice_number)
            ->setInvoice_type($invoice_type)
            ->setOrder_id($order_id);
    }
    /**
     * Get CUSTOMER_CODE value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCUSTOMER_CODE()
    {
        return isset($this->CUSTOMER_CODE) ? $this->CUSTOMER_CODE : null;
    }
    /**
     * Set CUSTOMER_CODE value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cUSTOMER_CODE
     * @return \Stellae\StructType\Shipment_status
     */
    public function setCUSTOMER_CODE($cUSTOMER_CODE = null)
    {
        // validation for constraint: string
        if (!is_null($cUSTOMER_CODE) && !is_string($cUSTOMER_CODE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cUSTOMER_CODE, true), gettype($cUSTOMER_CODE)), __LINE__);
        }
        if (is_null($cUSTOMER_CODE) || (is_array($cUSTOMER_CODE) && empty($cUSTOMER_CODE))) {
            unset($this->CUSTOMER_CODE);
        } else {
            $this->CUSTOMER_CODE = $cUSTOMER_CODE;
        }
        return $this;
    }
    /**
     * Get DELIVERY_DC_EDI value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDELIVERY_DC_EDI()
    {
        return isset($this->DELIVERY_DC_EDI) ? $this->DELIVERY_DC_EDI : null;
    }
    /**
     * Set DELIVERY_DC_EDI value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dELIVERY_DC_EDI
     * @return \Stellae\StructType\Shipment_status
     */
    public function setDELIVERY_DC_EDI($dELIVERY_DC_EDI = null)
    {
        // validation for constraint: string
        if (!is_null($dELIVERY_DC_EDI) && !is_string($dELIVERY_DC_EDI)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dELIVERY_DC_EDI, true), gettype($dELIVERY_DC_EDI)), __LINE__);
        }
        if (is_null($dELIVERY_DC_EDI) || (is_array($dELIVERY_DC_EDI) && empty($dELIVERY_DC_EDI))) {
            unset($this->DELIVERY_DC_EDI);
        } else {
            $this->DELIVERY_DC_EDI = $dELIVERY_DC_EDI;
        }
        return $this;
    }
    /**
     * Get DELIVERY_DOOR_EDI value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDELIVERY_DOOR_EDI()
    {
        return isset($this->DELIVERY_DOOR_EDI) ? $this->DELIVERY_DOOR_EDI : null;
    }
    /**
     * Set DELIVERY_DOOR_EDI value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dELIVERY_DOOR_EDI
     * @return \Stellae\StructType\Shipment_status
     */
    public function setDELIVERY_DOOR_EDI($dELIVERY_DOOR_EDI = null)
    {
        // validation for constraint: string
        if (!is_null($dELIVERY_DOOR_EDI) && !is_string($dELIVERY_DOOR_EDI)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dELIVERY_DOOR_EDI, true), gettype($dELIVERY_DOOR_EDI)), __LINE__);
        }
        if (is_null($dELIVERY_DOOR_EDI) || (is_array($dELIVERY_DOOR_EDI) && empty($dELIVERY_DOOR_EDI))) {
            unset($this->DELIVERY_DOOR_EDI);
        } else {
            $this->DELIVERY_DOOR_EDI = $dELIVERY_DOOR_EDI;
        }
        return $this;
    }
    /**
     * Get cartons value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Stellae\ArrayType\ArrayOfshipment_cartons|null
     */
    public function getCartons()
    {
        return isset($this->cartons) ? $this->cartons : null;
    }
    /**
     * Set cartons value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Stellae\ArrayType\ArrayOfshipment_cartons $cartons
     * @return \Stellae\StructType\Shipment_status
     */
    public function setCartons(\Stellae\ArrayType\ArrayOfshipment_cartons $cartons = null)
    {
        if (is_null($cartons) || (is_array($cartons) && empty($cartons))) {
            unset($this->cartons);
        } else {
            $this->cartons = $cartons;
        }
        return $this;
    }
    /**
     * Get invoice_date value
     * @return string|null
     */
    public function getInvoice_date()
    {
        return $this->invoice_date;
    }
    /**
     * Set invoice_date value
     * @param string $invoice_date
     * @return \Stellae\StructType\Shipment_status
     */
    public function setInvoice_date($invoice_date = null)
    {
        // validation for constraint: string
        if (!is_null($invoice_date) && !is_string($invoice_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoice_date, true), gettype($invoice_date)), __LINE__);
        }
        $this->invoice_date = $invoice_date;
        return $this;
    }
    /**
     * Get invoice_number value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInvoice_number()
    {
        return isset($this->invoice_number) ? $this->invoice_number : null;
    }
    /**
     * Set invoice_number value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $invoice_number
     * @return \Stellae\StructType\Shipment_status
     */
    public function setInvoice_number($invoice_number = null)
    {
        // validation for constraint: string
        if (!is_null($invoice_number) && !is_string($invoice_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoice_number, true), gettype($invoice_number)), __LINE__);
        }
        if (is_null($invoice_number) || (is_array($invoice_number) && empty($invoice_number))) {
            unset($this->invoice_number);
        } else {
            $this->invoice_number = $invoice_number;
        }
        return $this;
    }
    /**
     * Get invoice_type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInvoice_type()
    {
        return isset($this->invoice_type) ? $this->invoice_type : null;
    }
    /**
     * Set invoice_type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $invoice_type
     * @return \Stellae\StructType\Shipment_status
     */
    public function setInvoice_type($invoice_type = null)
    {
        // validation for constraint: string
        if (!is_null($invoice_type) && !is_string($invoice_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoice_type, true), gettype($invoice_type)), __LINE__);
        }
        if (is_null($invoice_type) || (is_array($invoice_type) && empty($invoice_type))) {
            unset($this->invoice_type);
        } else {
            $this->invoice_type = $invoice_type;
        }
        return $this;
    }
    /**
     * Get order_id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrder_id()
    {
        return isset($this->order_id) ? $this->order_id : null;
    }
    /**
     * Set order_id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $order_id
     * @return \Stellae\StructType\Shipment_status
     */
    public function setOrder_id($order_id = null)
    {
        // validation for constraint: string
        if (!is_null($order_id) && !is_string($order_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($order_id, true), gettype($order_id)), __LINE__);
        }
        if (is_null($order_id) || (is_array($order_id) && empty($order_id))) {
            unset($this->order_id);
        } else {
            $this->order_id = $order_id;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Stellae\StructType\Shipment_status
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
